; #########################################################################

    .486                      ; create 32 bit code
    .model flat, stdcall      ; 32 bit memory model
    option casemap :none      ; case sensitive

    include drawline.inc      ; local includes for this file

    CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM

.code

; #########################################################################

start:

      call Main
      invoke ExitProcess,eax

; #########################################################################

Main proc

    LOCAL hWnd     :DWORD
    LOCAL hCursor  :DWORD
    LOCAL hIcon    :DWORD
    LOCAL msg      :MSG
    LOCAL wc       :WNDCLASSEX

    invoke LoadCursor,NULL,IDC_ARROW
    mov hCursor, eax

    invoke LoadIcon,NULL,IDI_ASTERISK
    mov hIcon, eax

    szText szClassName,"smallwin_Class"
    szText szDisplayName,"Drawing Lines with the Mouse"

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_VREDRAW or \
                           CS_HREDRAW
    mov wc.lpfnWndProc,    offset WndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    mov wc.hInstance,      400000h
    mov wc.hbrBackground,  COLOR_BTNFACE+1
    mov wc.lpszMenuName,   NULL
    mov wc.lpszClassName,  offset szClassName
    m2m wc.hIcon,          hIcon
    m2m wc.hCursor,        hCursor
    m2m wc.hIconSm,        hIcon

    invoke RegisterClassEx, ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          150,150,500,300,
                          NULL,NULL,
                          400000h,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

  StartLoop:
    invoke DispatchMessage,  ADDR msg
    invoke GetMessage,ADDR msg,NULL,0,0
    cmp eax, 0
    jne StartLoop

    mov eax, msg.wParam
    ret

Main endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL Ps :PAINTSTRUCT
    LOCAL Rct:RECT

    .if uMsg == WM_DESTROY
      invoke PostQuitMessage,NULL
      return 0

    .elseif uMsg == WM_LBUTTONDOWN
	invoke SetCapture,hWin	; Capture mouse input.

	push esi
	lea esi, Rct
	; Retrieve screen coordinates
	invoke GetClientRect,hWin,esi
	pop esi
				; Add one to the right
	add Rct.right,1		; and bottom sides, because
				; coordinates retrieved by
				; GetClientRect do not
	add Rct.bottom,1	; include the far left
				; and lowermost pixels.

	; Retrieve the screen coordinates of the client area, 
	; and convert them into client coordinates. 
	invoke MapWindowPoints,hWin,NULL,ADDR Rct,2

	; Copy the client coordinates of the client area.
	; Confine the mouse cursor to the client area by
	; passing the Rct structure to the ClipCursor function.
	invoke SetRect,edi, Rct.left, Rct.top,
	                    Rct.right, Rct.bottom 
	invoke ClipCursor,edi

	movsx edx, WORD PTR [ebp + 20]
	mov ptBEGIN.x,edx
	movsx edx, WORD PTR [ebp + 22]
	mov ptBEGIN.y,edx
	return 0

    .elseif uMsg == WM_MOUSEMOVE

      .if wParam == MK_LBUTTON
	    push esi
	    invoke GetDC,hWin
	    push eax
	    pop esi
	    .if PrevLine == 1
		invoke SetROP2,esi, R2_NOTXORPEN
		invoke MoveToEx,esi,ptBEGIN.x,ptBEGIN.y,NULL
		invoke LineTo,esi,ptEND.x,ptEND.y
	    .endif
	    movsx edx, WORD PTR [ebp + 20]
	    mov ptEND.x,edx
	    movsx edx, WORD PTR [ebp + 22]
	    mov ptEND.y,edx
	    invoke MoveToEx,esi,ptBEGIN.x,ptBEGIN.y,NULL
	    invoke LineTo,esi,ptEND.x,ptEND.y
	    mov PrevLine,1
	    invoke ReleaseDC,hWin,esi
	    invoke InvalidateRect,hWin,NULL,TRUE
	.endif
	return 0

    .elseif uMsg == WM_LBUTTONUP
        mov PrevLine,0
        invoke ClipCursor,NULL
        call ReleaseCapture
	return 0
        
    .elseif uMsg==WM_PAINT
      push esi
      push edi
      push ebx
        lea esi, Rct
        lea ebx, Ps
        invoke BeginPaint,hWin,ebx
        push eax
        pop edi
        invoke GetClientRect,hWin,esi
	invoke SetBkMode,edi,TRANSPARENT
	invoke MoveToEx,edi,ptBEGIN.x,ptBEGIN.y,NULL
	invoke LineTo,edi,ptEND.x,ptEND.y
	invoke SetBkMode,edi,OPAQUE
        invoke EndPaint,hWin,ebx
      pop ebx
      pop edi
      pop esi
      return 0

    .else

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

    .endif

    return 0

WndProc endp

; ########################################################################

end start
